(* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *)
(*  Soubor: MYS3.PAS                                                       *)
(*  Obsah: procedury a funkce pro ovladani mysi ve VESA grafice            *)
(*  Autor: Mircosoft (vetsinou)                                            *)
(*  Posledni uprava: 23.2.2006                                             *)
(*  Pro kompilaci: VESA.TPU, ERRMSG.TPU                                    *)
(*  Pro spusteni: nejaky soubor s kurzorem (obvykle *.KUR)                 *)
(*  Upozorneni: tyto zdrojove kody pouzivate na vlastni nebezpeci          *)
(* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *)
unit Mys3;
{$I-,B-} {nutne}
{$X-,R-,S-,F-,Q-} {jen prkotiny pro drobne urychleni}
{$D-,L-}
interface

type
hotspot = object {obdelnik na obrazovce, na ktery se da kliknout (mozna divny nazev, ale to je jedno)}
          a,b,c,d:integer;{[a,b] je levy horni roh, [c,d] pravy dolni}
          hHodnota:byte;{kterym mysitkem sem bylo od posledni kontroly kliknuto}
          procedure init(ia,ib,ic,id:integer);{inicializuje souradnice}
          procedure kontrola(resb:boolean);{pokud je mys v tom obdelniku,
            ulozi se stav tlacitek do polozky hHodnota. Pokud bylo nejake
            tlacitko stisknuto a resb=true, pak se jeste pocka na uvolneni
            vsech tlacitek mysi}
          function klik:byte;{vraci a nuluje hHodnotu}
          end;{hotspot}


tKurzor = record {struktura pro uchovavani informaci o kurzorech}
          sk,vk:byte;{sirka a vyska kurzoru (v pixelech)}
          hsx,hsy:shortint;{souradnice aktivniho bodu kurzoru od leveho horniho rohu bitmapy
                            (pocitano od nuly, obrazek kurzoru se kresli na [xmys-hsx,ymys-hsy])}
          kData:pointer;{ukazatel na bitmapu (obycejny obrazek pro _puttimage)}
          end;


var Xmys,Ymys:integer;{poloha mysi}
    PocetTlacitek,{pocet tlacitek mysi, obvykle 2 nebo 3, detekuje ho procedura InitMys}
    StavTlacitek:word;{1=leve, 2=prave, 4=stredni (kdyz je stisknuto vic tlacitek najednou, sectou se)}
    Lmys,Pmys,Smys:boolean;{jestli je stisknuto prislusne tlacitko (jen rozdelena promenna Stavtlacitek)}
    kurzorB:boolean;{jestli je zapnuty kurzor}

(************************** inicializace a zruseni **************************)
procedure InitMys;
{Tuhle proceduru urcite zavolejte pote, co spustite graficky rezim.
Hardwarove inicializuje mys (pripadne zjisti, ze nefunguje), zjisti pocet
tlacitek, nastavi rozsah pohybu mysi na celou obrazovku, umisti kurzor do
stredu obrazovky, nastavi citlivost mysi na primerene hodnoty a zavola
StavMysi. Nezapina kurzor - nejdriv je potreba pouzit proceduru NastavKurzor
(viz dale). Take rusi jakoukoli pripadnou automatickou obsluhu mysi.}
procedure ZrusMys;
{Vypne automatickou obsluhu mysi, vypne kurzor a uvolni pamet, do ktere se
uklada jeho pozadi. Pro opetovne rozchozeni mysi staci pouzit Nastavkurzor
a pripadne Zapniobsluhumysi.}

(******************************** kurzory ***********************************)
procedure NactiKurzor(var kam:tkurzor; var f:file);
{Nacte kurzor ze souboru do promenne, bez kontroly I/O.
 kam - cilova promenna. Potrebna pamet je procedurou alokovana.
 f - beztypovy soubor, ktery musi byt otevren pro cteni s velikosti bloku 1 B
     (reset(f,1);) a kurzor v nem musi byt prave na zacatku dat kurzoru.
Pro nacitani z vetsich souboru, ve kterych neni jen jeden kurzor.
Popis formatu souboru s kurzorem je na konci teto jednotky.}
procedure NactiKurzor2(var kam:tkurzor; soubor:string);
{To same, ale zada se jenom jmeno souboru (obvykle s koncovkou KUR), procedura
si ho otevre, nacte kurzor a zase ho zavre. Pro nacitani ze samostatnych
souboru, ktere obsahuji jen ten kurzor.
Pokud je po skonceni procedury kam.kdata=nil, znamena to, ze nastala I/O
chyba pri otvirani souboru (obvykle to znamena, ze soubor neexistuje).}
procedure ZrusKurzor(var Ktery:tkurzor);
{uvolni pamet, kterou ma pro sebe alokovanou kurzor Ktery. Po skonceni
procedury je ktery.kData=nil}
procedure NastavKurzor(var Jaky:tkurzor);
{Prepne na dany kurzor. Je potreba to provest pred prvnim zapnutim kurzoru.
Pamet pro obrazek kurzoru se nealokuje, jen se nasmeruje prislusny interni
ukazatel na obrazek v promenne Jaky; tuto promennou proto nemazte, dokud
kurzor pouzivate.}

(************ univerzalni procedury a funkce pouzitelne kdykoli *************)
procedure StavMysi;
{Aktualizuje promenne xmys, ymys, stavtlacitek, lmys, pmys a smys,
o zobrazovani kurzoru se vubec nestara.}
procedure kZap;
{Zapne kurzor. Je treba, aby byl nejaky kurzor nastaven (viz Nastavkurzor).
Pokud nebude, nezapne se.}
procedure kVyp;
{Vypne kurzor.}
function Kliknuto:boolean;
{zkraceny zapis stavtlacitek<>0 (netestuje mys)}
procedure PresunMys(noveX,noveY:word);
{Presune mys na dane souradnice. Pokud je kurzor zapnuty, postara se o nej.}
procedure MezeMysi(x1,y1,x2,y2:word);
{Vymezi obdelnikovy prostor, mimo ktery mys nemuze. Pokud se kurzor nachazel
mimo tu oblast, presune ho dovnitr na nejblizsi hranici. O spravne zobrazeni
kurzoru se postara.}
function MysVPoli(x1,y1,x2,y2:integer):boolean;
{Zjisti,jestli je mys v danem obdelnikovem poli na obrazovce. [x1,x2] je levy
horni roh pole, [x2,y2] pravy dolni (bez kontroly => neprohodit!).
Netestuje mys, jen porovna hodnoty xmys a ymys se zadanymi souradnicemi.}
procedure CitlivostMysi(vodorovne,svisle:word);
{cim vetsi cisla, tim mensi citlivost. Nejvetsi je pri 1, optimum je cca 9
pro oba smery}

(****************** procedury pro rucni obsluhu kurzoru: ********************)
{Tyto procedury sice funguji i pri automaticke obsluze mysi, ale v takovem
pripade je lepsi volat ty specialni (viz dale), protoze jsou o malinko
rychlejsi (nevolaji proceduru Kurzor).}
procedure Kurzor;
{Vlastni obsluha kurzoru. Precte stav mysi a pokud se kurzor od minuleho
volani teto procedury pohnul a je zapnuty, presune ho do nove polohy.}
procedure Cekej;
{Ceka na stisk libovolneho tlacitka nebo klavesy a mezitim se stara
o zobrazovani pohybu kurzoru.}
procedure CekejNaCokoli;
{Ceka na stisk libovolneho tlacitka nebo klavesy nebo na pohnuti mysi a
mezitim se stara o kurzor.}
procedure Resetuj;
{Pocka na uvolneni vsech cudliku na klavesnici i na mysi a stara se o kurzor.}

(*************** procedury pro automatickou obsluhu kurzoru: ****************)
procedure ZapniObsluhuMysi;
{Nastavi proceduru pro automatickou obsluhu zobrazovani kurzoru a cteni stavu
tlacitek, takze to vsechno pobezi na pozadi a nemusite se o to starat.}
procedure ZrusObsluhuMysi;
{Zrusi automatickou obsluhu mysi. Pred koncem programu je nutne tuto proceduru
(nebo ZrusMys, ve ktere je zabudovana) pouzit!!!}
procedure Cekej2;
procedure CekejNaCokoli2;
procedure Resetuj2;
{Funguji stejne jako ty pro rucni obsluhu, ale JEN pri automaticke obsluze.
Pokud je zkusite zavolat bez automaticke obsluhy, program se pravdepodobne
zasekne v nekonecne smycce.}

implementation
uses errmsg,vesa;

var _pk:pointer;{ukazatel na pozadi kurzoru}
    _kx,_ky:integer;{souradnice kurzoru}
    _sk,_vk:word;{sirka a vyska kurzoru}
    _hsx,_hsy:integer;{souradnice aktivniho bodu}
    _lhx,_lhy:integer;{pomocne souradnice leveho horniho rohu pozadi kurzoru}
    _kurP:pointer;{ukazatel na obrazek kurzoru}
    _PreruseniNastaveno:boolean;{jestli je aktivovana automaticka obsluha}

{procedura, ktera bude automaticky volana pri kazdem pohnuti mysi
nebo pohybu nektereho tlacitka:}
procedure _ObsluhaMysi; interrupt;{v AThelpu se sice pise, ze ma byt jen far
              a ne interrupt, ale mne jako far padala a interrupt to vyresil}
Begin
asm
{tyhle registry ovladac pred zavolanim procedury nastavil:}
mov stavtlacitek,BX
mov xmys,CX
mov ymys,DX
test AX,$7E  {V AX je kod udalosti, ktera zpusobila vyvolani teto procedury
              (odpovida masce v CX pri nastavovani obsluhy - viz dale).
              Pokud je AX = 1 (nastal pouze pohyb mysi), preskoci se usek
              zpracovani stavu tlacitek.}
jz @TlacitkaSeNezmenila
 mov AX,BX
 or AH,AL        {AH = AL = stav tlacitek}
 and BL,1        {stisknuto leve?}
 mov lmys,BL     {uloz do lmys}
 shr AX,1        {AH i AL o bit doprava}
 and AL,1        {stisknuto prave?}
 mov pmys,AL     {uloz do pmys}
 shr AH,1        {AH o bit doprava}
                 {stisknuto prostredni?}
 mov smys,AH     {uloz do smys}
@TlacitkaSeNezmenila:
end;
if kurzorb and ((xmys<>_kx)or(ymys<>_ky)) then {kdyz je zapnuty kurzor a bylo jim pohnuto}
 begin
 _putimage(_lhx,_lhy,_sk,_vk,_pk);{zobrazeni pozadi - vymazani kurzoru}
 _kx:=xmys; _ky:=ymys;{ulozeni nove polohy kurzoru}
 _lhx:=_kx-_hsx; _lhy:=_ky-_hsy;    {levy horni roh pozadi kurzoru}
 if _lhx<0 then _lhx:=0;    {aby nevycuhoval levy nebo horni okraj z obrazovky (kvuli _getimage)}
 if _lhy<0 then _lhy:=0;
 if _lhx+_sk-1>_maxx then _lhx:=_maxx-_sk+1;  {aby nevycuhoval ani pravy nebo dolni okraj}
 if _lhy+_vk-1>_maxy then _lhy:=_maxy-_vk+1;
 _getimage(_lhx,_lhy,_lhx+_sk-1,_lhy+_vk-1,_pk);{nacteni pozadi kurzoru}
 _puttimage(_kx-_hsx,_ky-_hsy,_sk,_vk,_kurp);{zobrazeni kurzoru}
 end;
End;{_obsluhamysi}

procedure ZapniObsluhuMysi;
var AdresaObsluhy:pointer;
Begin
if not _preruseninastaveno then
 begin
 adresaobsluhy:=@_obsluhamysi;
 asm
 mov AX,12    {AX = 12 - sluzba "nastav proceduru pro obsluhu mysi"}
 mov CX,$007F {CX = maska, pri jakych prilezitostech se ma procedura zavolat:}
 les DX,adresaobsluhy           { 01111111   volat pri:                           }
 mov BX,DX                      {  pohybu mysi                          }
{podle nekterych pramenu to}    {  stisku leveho tlacitka               }
{pry ma byt BX a ne DX, tak}    {  uvolneni -"-                         }
{tam radsi dam oboje       }    {  stisku praveho tl.                   }
 int $33                        {  uvolneni -"-                         }
 end;                           {  stisku prostredniho tl.              }
 _preruseninastaveno:=true;     {  uvolneni -"-                         }
 end;                           {  tenhle a vyssi bity uz nejsou vyuzity}
End;{zapniobsluhumysi}

procedure ZrusObsluhuMysi;
var AdresaObsluhy:pointer;
Begin
if _preruseninastaveno then
 begin
 adresaobsluhy:=@_obsluhamysi;
 asm
 mov AX,12
 xor CX,CX     {maska = 0 - nevolat proceduru vubec, cili tak se to zrusi}
 les DX,adresaobsluhy {nevim, jestli je tohle nutne, tak to radsi nastavim}
 mov BX,DX
 int $33
 end;
 _preruseninastaveno:=false;
 end;
End;{zrusobsluhumysi}

procedure hotspot.init(ia,ib,ic,id:integer);
Begin
a:=ia; b:=ib; c:=ic; d:=id; hhodnota:=0;
End;{hotspot.init}

procedure hotspot.kontrola(resb:boolean);
Begin
if mysvpoli(a,b,c,d) then
  begin
  hhodnota:=stavtlacitek;{ulozeni, cim bylo kliknuto}
  if (stavtlacitek<>0) and resb then resetuj;{pripadne pockani na uvolneni mysi}
  end
 else hhodnota:=0;{mys je mimo oblast}
End;{hotspot.kontrola}

function hotspot.klik:byte;
Begin
klik:=hhodnota;
hhodnota:=0;
End;{hotspot.klik}

procedure InitMys;
var pom:word;
Begin
{nejdriv bych mozna mel otestovat, jestli existuje preruseni $33, ale na to
bych sem musel tahat jednotku Dos kvuli Getintvec... a stejne, jestli nekdo
vubec nema mys a vi to (jak by mohl nevedet?), tak proc by si poustel
takovehle programy, ze jo? :-)}
asm
xor AX,AX  {AX = 0 - sluzba "reset a inicializace mysi"}
int $33
mov pocettlacitek,BX
mov pom,AX
end;
if pom=0 then chyba('Vase mys bud nefunguje, neexistuje nebo k ni nemate ovladac.',2)
         else begin
              citlivostmysi(9,9);{takhle mi vyhovuje nejvic}
              mezemysi(0,0,_maxx,_maxy);{meze mysi = cela obrazovka}
              presunmys(_maxx shr 1,_maxy shr 1);{kurzor do stredu obrazovky}
              StavMysi;{inicializace zbyvajicich promennych}
              end;
End;{initmys}

procedure NactiKurzor(var kam:tkurzor; var f:file);
Begin
with kam do
  begin
  blockread(f,sk,1);
  blockread(f,vk,1);
  blockread(f,hsx,1);
  blockread(f,hsy,1);
  if (ioresult=0)and(sk*vk<=maxavail) then begin
                                           getmem(kdata,sk*vk);
                                           blockread(f,kdata^,sk*vk);
                                           if ioresult<>0 then begin
                                                               freemem(kdata,sk*vk);
                                                               kdata:=nil;
                                                               end;
                                           end
                                      else kdata:=nil;
  end;
End;{nactikurzor}

procedure NactiKurzor2(var kam:tkurzor; soubor:string);
var f:file;
Begin
assign(f,soubor);
reset(f,1);
if ioresult=0 then begin
                   nactikurzor(kam,f);
                   close(f);
                   end
              else kam.kdata:=nil;
End;{nactikurzor2}

procedure ZrusKurzor(var ktery:tkurzor);
Begin
with ktery do begin
              freemem(kdata,sk*vk);
              kdata:=nil;{pro kontrolu}
              end;
End;{zruskurzor}

procedure NastavKurzor(var jaky:tkurzor);
var bylkurzor:boolean;
Begin
if jaky.kdata=nil then exit;{kurzor neni nacten}
bylkurzor:=kurzorb; kvyp;
if _pk<>nil then begin{zruseni pozadi predchoziho kurzoru}
                 freemem(_pk,_sk*_vk);
                 _pk:=nil;
                 end;
with jaky do
  begin
  _sk:=sk; _vk:=vk;
  _hsx:=hsx; _hsy:=hsy;
  if maxavail<_sk*_vk then bylkurzor:=false{zabranime zapnuti (lepsi nez se patlat s chybovymi hlaskami)}
                      else begin
                           getmem(_pk,_sk*_vk);{nova pamet pro pozadi}
                           _kurp:=kdata;{nastaveni ukazatele na obrazek}
                           end;
  end;
if bylkurzor then kzap;
End;{nastavkurzor}

procedure ZrusMys;
Begin
if _preruseninastaveno then zrusobsluhumysi;
kvyp;
if _pk<>nil then begin
                 freemem(_pk,_sk*_vk); {uvolneni pameti pro pozadi kurzoru}
                 _pk:=nil;
                 end;
_kurp:=nil; {nutne, aby se kurzor nedal zapnout, kdyz nema alokovane pozadi}
End;{zrusmys}

procedure StavMysi; assembler;
Asm
mov AX,3     {AX = 3 - sluzba "cteni stavu mysi"}
int 33h
mov xmys,CX
mov ymys,DX
mov stavtlacitek,BX
mov AX,BX          {zpracovani tlacitek je stejne jako v procedure _obsluhamysi:}
or AH,AL
and BL,1        {true=1, false=0}
mov lmys,BL                {lmys:=(stavtlacitek and 1)=1;}
shr AX,1
and AL,1
mov pmys,AL                {pmys:=(stavtlacitek shr 1)and 1 =1;}
shr AH,1
mov smys,AH                {smys:=(stavtlacitek shr 2)=1;}
End;{stavmysi}

procedure kurzor;
Begin
if not _preruseninastaveno then
 begin
 stavmysi;
 {dale to same jako v procedure _ObsluhaMysi:}
 if kurzorb and ((xmys<>_kx)or(ymys<>_ky)) then
  begin
  _putimage(_lhx,_lhy,_sk,_vk,_pk);
  _kx:=xmys; _ky:=ymys;
  _lhx:=_kx-_hsx; _lhy:=_ky-_hsy;
  if _lhx<0 then _lhx:=0;
  if _lhy<0 then _lhy:=0;
  if _lhx+_sk-1>_maxx then _lhx:=_maxx-_sk+1;
  if _lhy+_vk-1>_maxy then _lhy:=_maxy-_vk+1;
  _getimage(_lhx,_lhy,_lhx+_sk-1,_lhy+_vk-1,_pk);
  _puttimage(_kx-_hsx,_ky-_hsy,_sk,_vk,_kurp);
  end;
 end;
End;{kurzor}

procedure kZap;
Begin
if (_kurp<>nil) and not kurzorb then
 begin
 if not _preruseninastaveno then stavmysi;
 _kx:=xmys; _ky:=ymys;
 _lhx:=_kx-_hsx; _lhy:=_ky-_hsy;
 if _lhx<0 then _lhx:=0;
 if _lhy<0 then _lhy:=0;
 if _lhx+_sk-1>_maxx then _lhx:=_maxx-_sk+1;
 if _lhy+_vk-1>_maxy then _lhy:=_maxy-_vk+1;
 _getimage(_lhx,_lhy,_lhx+_sk-1,_lhy+_vk-1,_pk);
 _puttimage(_kx-_hsx,_ky-_hsy,_sk,_vk,_kurp);
 kurzorb:=true;{tohle musi byt az na konci, kvuli automatice}
 end;
End;{kzap}

procedure kVyp;
Begin
if kurzorb then
 begin
 kurzorb:=false;{tohle musi byt hned na zacatku, kvuli automatice}
 _putimage(_lhx,_lhy,_sk,_vk,_pk);
 end;
End;{kvyp}

function kliknuto:boolean; assembler;
Asm
mov AX,stavtlacitek   {kliknuto:=stavtlacitek<>0;}
{navratova hodnota funkce se vraci v AX (AL), pokud je to nenulove cislo, je to true}
End;{kliknuto}

procedure Mezemysi(x1,y1,x2,y2:word); assembler;
Asm
mov AL,kurzorb
push AX           {ulozime stav kurzoru na zasobnik}
or AL,AL          {je to nula (false)?}
jz @JdemeNaTo     {ano => neni treba kurzor vypinat, skocime na navesti @jdemenato}
 call kvyp         {vypnuti kurzoru}
@JdemeNaTo:
mov AX,7     {AX = 7 - sluzba "nastaveni x-oveho rozsahu mysi"}
mov CX,x1
mov DX,x2
int $33
mov AX,8     {AX = 8 - sluzba "nastaveni y-oveho rozsahu mysi"}
mov CX,y2
mov DX,y1
int $33
pop AX       {nacteni ulozeneho stavu kurzoru ze zasobniku}
or AL,AL     {je (byla) to 0?}
jz @konec    {byla => nemusime nic zapinat, hop na konec}
 call kzap    {zapnuti kurzoru}
@konec:
End;{mezemysi}

procedure presunmys(novex,novey:word); assembler;
Asm
mov AL,kurzorb
push AX                    {ulozeni stavu kurzoru}
or AL,AL
jz @jdemenato
 call kvyp
@jdemenato:
mov AX,4         {AX = 4 - sluzba "presun mysi"}
mov CX,novex
mov DX,novey
mov xmys,CX      {ulozeni novych souradnic}
mov ymys,DX
int $33
pop AX                     {obnoveni kurzoru do puvodniho stavu}
or AL,AL
jz @konec
 call kzap
@konec:
End;{presunmys}

procedure cekejnacokoli; assembler;
var mnlx,mnly:word;
Asm
call kurzor          {kurzor;}
mov AX,xmys
mov mnlx,AX          {mnlx:=xmys}
mov AX,ymys
mov mnly,AX          {mnly:=ymys}
 @cekani:    {repeat}
 call kurzor
 mov AX,xmys
 cmp AX,mnlx
 jne @konec       {if xmys<>mnlx then goto @konec}
 mov AX,ymys
 cmp AX,mnly
 jne @konec       {if ymys<>mnly then goto @konec}
 mov AX,stavtlacitek
 or AX,AX
 jnz @konec       {if kliknuto then goto @konec}
 mov AX,$0B00
 int $21
 or AL,AL
 jz @cekani       {if not keypressed then goto @cekani}
@konec:
End;{cekejnacokoli}

procedure cekej; assembler;
Asm                {repeat kurzor until (stavtlacitek<>0) or keypressed;}
 @cekani:
 call kurzor
 mov AX,stavtlacitek
 or AX,AX
 jnz @konec {if kliknuto then goto @konec}
 mov AX,$0B00
 int $21
 or AL,AL
 jz @cekani {if not keypressed then goto @cekani}
@konec:
End;{cekej}

procedure resetuj; assembler;
Asm
 @cekani:
 call kurzor
 mov AX,stavtlacitek
 or AX,AX
 jnz @cekani {if stavtlacitek<>0 then goto @cekani}
mov AX,$0C06
mov DL,$FF
int $21           {reset bufferu klavesnice}
End;{resetuj}

function mysvpoli(x1,y1,x2,y2:integer):boolean;
Begin
mysvpoli:=(xmys>=x1)and(xmys<=x2)and(ymys>=y1)and(ymys<=y2);
End;{mysvpoli}

procedure citlivostmysi(vodorovne,svisle:word); assembler;
Asm
mov AX,15         {AX = 15 - sluzba "nastav citlivost mysi"}
mov CX,vodorovne
mov DX,svisle
int $33
End;{citlivostmysi}

procedure cekejnacokoli2; assembler;
var mnlx,mnly:word;
Asm
{kurzor se o sebe stara sam}
mov AX,xmys
mov mnlx,AX          {mnlx:=xmys}
mov AX,ymys
mov mnly,AX          {mnly:=ymys}
 @cekani:    {repeat}
 call kurzor
 mov AX,xmys
 cmp AX,mnlx
 jne @konec       {if xmys<>mnlx then goto @konec}
 mov AX,ymys
 cmp AX,mnly
 jne @konec       {if ymys<>mnly then goto @konec}
 mov AX,stavtlacitek
 or AX,AX
 jnz @konec       {if kliknuto then goto @konec}
 mov AX,$0B00
 int $21
 or AL,AL
 jz @cekani       {if not keypressed then goto @cekani}
@konec:
End;{cekejnacokoli2}

procedure cekej2; assembler;
Asm
 @cekani:
 mov AX,stavtlacitek
 or AX,AX
 jnz @konec {if kliknuto then goto @konec}
 mov AX,$0B00
 int $21
 or AL,AL
 jz @cekani {if not keypressed then goto @cekani}
@konec:
End;{cekej2}

procedure resetuj2; assembler;
Asm
 @cekani:
 call kurzor
 mov AX,stavtlacitek
 or AX,AX
 jnz @cekani {if stavtlacitek<>0 then goto @cekani}
mov AX,$0C06
mov DL,$FF
int $21           {reset bufferu klavesnice}
End;{resetuj2}

BEGIN
_kurp:=nil; _pk:=nil; kurzorb:=false;
_preruseninastaveno:=false;
END.

{Struktura dat v souboru *.KUR:

 sirka kurzoru v pixelech (byte)
 vyska kurzoru v pixelech (byte)
 xova souradnice aktivniho bodu v pixelech (shortint)
 yova souradnice aktivniho bodu v pixelech (shortint)
 bitmapa kurzoru (array[1..vyska,1..sirka] of byte)

Bitmapa je vlastni obrazek kurzoru - seznam pixelu razeny po radcich, kde
1 byte = 1 pixel. 256 barev, hodnota 0 znamena pruhledny pixel. Primo pro
__Puttimage.
Souradnice aktivniho bodu jsou mereny od leveho horniho rohu bitmapy (kdyby
byl primo tam, mel by souradnice 0,0; + je vpravo a dole, - vlevo a nahore).

Pozor, toto neni zadny oficialni format.}
