(* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *)
(*  Soubor: RETEZCE.PAS                                                    *)
(*  Obsah: procedury a funkce pro operace s retezci                        *)
(*  Autor: Mircosoft                                                       *)
(*  Posledni uprava: 24.7.2006                                             *)
(*  Pro kompilaci: nic                                                     *)
(*  Pro spusteni: nic                                                      *)
(*  Upozorneni: tyto zdrojove kody pouzivate na vlastni nebezpeci          *)
(* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *)
unit Retezce;
interface

const _Doleva=0;
      _NaStred=1;
      _Doprava=2;
      _Orezat=4;

function KolikCeho(Kolik:byte; Ceho:char):string;
{Vrati retezec vyplneny jednim typem znaku.
 Kolik - delka retezce, Ceho - znak, kterym se ma retezec vyplnit}
function Zarovnej(Co:string; NaKolik:word; Jak:byte; Cim:char):string;
{Vraci dany retezec upraveny na danou delku. Parametry:
 Co - retezec, ktery se ma upravit
 NaKolik - pozadovana delka vysledneho retezce
 Jak - zpusob zarovnani. Mozne hodnoty:_Doleva, _NaStred, _Doprava (viz vyse).
       Kdyz je retezec kratsi, prodlouzi se. Kdyz je delsi, nic se s nim
       nedela. Pokud ale k Jak prictete konstantu _Orezat, bude zkracen.
 Cim - pokud se bude retezec prodluzovat, doplni se temito znaky.}
function NaStr(a:longint):string;
{prevede parametr na retezec}
function NaStr2(a:longint;NaKolik:byte):string;
{to same, ale zadava se i pozadovana delka vysledneho retezce}
function NaStr3(a:longint;NaKolik:byte):string;
{podobne, ale aby cislo protahla na pozadovanou delku, vklada pred nej nuly}
function NaStrR(a:real;DesMista:byte):string;
{pro realna cisla; zadava se pocet desetinnych mist, sirka zustava vychozi
(nejmensi mozna)}
function StringUp(s:string):string;
{vraci retezec s prevedeny na velka pismena (nebere diakritiku)}
function StringDown(s:string):string;
{vraci retezec s prevedeny na mala pismena (nebere diakritiku)}
function BHC(s:string):string;
{Vraci retezec S bez hacku a carek. Pro pripady, kdy neni k dispozici ceska
znakova sada s kodovanim Latin 2 a zobrazuji se paznaky.}
function ValF(retezec:string; default:longint):longint;
{Prevede cislo zadane v textu Retezec na ciselnou hodnotu. Pokud se to
nepovede (chyba v zapisu cisla atd.), vrati se hodnota Default, kterou si
zadate dle potreby.}

{datove struktury a procedury pro ukladani textu:}
type
UkNaRadek = ^tRadek; {tenhle typ pouzivejte k vytvareni promennych}
tRadek = record {tohle je jenom sablona pro spojovy seznam}
         dalsi:UkNaRadek;
         obsah:string;
         end;
{jestli se v tom hodlate vrtat, urcite neprohodte poradi polozek - Obsah musi
byt az na konci. Pro radek se totiz alokuje jen tolik pameti, kolik je zrovna
podle jeho delky potreba, tudiz neni predem dano, kde presne retezec konci
a k cemukoli za nim by neslo normalne (pres tecku) pristupovat.}

procedure NactiTexty(var Kam:uknaradek; Odkud:string; Sirka:byte);
{Za ukazatelem Kam vytvori spojovy seznam radku, ktere nacte z retezce Odkud.
Sirka je pozadovana maximalni sirka radku (ve znacich). Ke kazdemu radku se
vzdycky pridavaji slova tak dlouho, dokud tuto delku neprekroci (pozor,
prekrocit ji tedy muze, ale maximalne o delku jednoho slova). Pokud
potrebujete odradkovat rucne, dela se to znakem '|'.
Pokud na cely text nevystaci pamet, ulozi se jen tolik radku, na kolik
stacila - zadne chybove hlaseni, zadne ukoncovani programu.
Pro pridavani dalsich radku do jiz hotoveho seznamu se procedura pouzije uplne
stejne (Kam je potom ukazatel na libovolny radek jiz hotoveho seznamu).
 POZOR: pri vytvareni NOVEHO seznamu musi byt ukazatel, ktery predavate v
parametru Kam, bezpodminecne nutne nastaven na NIL, jinak si procedura bude
myslet, ze tam uz nejaky seznam je, pokusi se najit jeho konec (ktery tam
neni), zacne zapisovat do nealokovane pameti a skonci to Nepovolenou Aplikaci!}
function NejdelsiRadek(Ceho:uknaradek):byte;
{vraci delku nejdelsiho radku v danem seznamu}
function PocetRadkuVSeznamu(VeKterem:uknaradek):byte;
{vraci pocet radku v danem seznamu}
procedure ZrusTexty(var Ktere:uknaradek);
{zrusi seznam radku, na ktery ukazuje ukazatel Ktere (ten pak bude nil)}

implementation

function kolikceho(kolik:byte;ceho:char):string;
var s:string;
Begin
byte(s[0]):=kolik;{nastaveni delky}
fillchar(s[1],kolik,ceho);{vyplneni obsahu}
kolikceho:=s;{vraceni vysledku}
End;{kolikceho}

function zarovnej(co:string;nakolik:word;jak:byte;cim:char):string;
var orezb:boolean;
Begin
orezb:=jak>=4;{ma se orezavat?}
jak:=jak and 3;{vynulovani "orezavaciho" bitu, aby se na nej nemusel brat ohled pri Case}
if byte(co[0])<nakolik{retezec je kratsi, bude se prodluzovat}
 then case jak of _doleva:co:=co+kolikceho(nakolik-byte(co[0]),cim);{prodlouzime konec retezce}
                  _nastred:begin         {byte(retezec[0])=length(retezec) (aby bylo jasno :-) )}
                           co:=kolikceho((nakolik-byte(co[0])) shr 1,cim)+co;{nejdriv prodlouzit konec o pulku rozdilu...}
                           co:=co+kolikceho((nakolik-byte(co[0])),cim);{...potom zacatek o zbytek}
                           end;
                  _doprava:co:=kolikceho(nakolik-byte(co[0]),cim)+co;{prodlouzime zacatek retezce}
                  end
 else if (byte(co[0])>nakolik)and orezb{retezec je delsi, zkrati se}
             then case jak of _doleva:dec(byte(co[0]),byte(co[0])-nakolik);{uriznuti konce = proste zmenseni jeho delky}
                              _nastred:begin
                                       delete(co,1,(byte(co[0])-nakolik)shr 1);{nejdriv uriznuti zacatku o pul rozdilu...}
                                       dec(byte(co[0]),byte(co[0])-nakolik);{...pak uriznuti konce o zbytek}
                                       end;
                              _doprava:delete(co,1,byte(co[0])-nakolik);{uriznuti znaku ze zacatku}
                              end;
zarovnej:=co;
End;{zarovnej}

function nastr(a:longint):string;
var vysl:string[11];{nejdelsi mozny longint}
Begin
str(a,vysl);
nastr:=vysl;
End;{nastr}

function nastr2(a:longint;nakolik:byte):string;
var vysl:string[80];{snad staci}
Begin
str(a:nakolik,vysl);
nastr2:=vysl;
End;{nastr2}

function NaStr3(a:longint;NaKolik:byte):string;
var vysl:string[80];
Begin
str(a,vysl);
while byte(vysl[0])<nakolik do vysl:='0'+vysl;
nastr3:=vysl;
End;{nastr3}

function NaStrR(a:real;DesMista:byte):string;
var vysl:string[80];
Begin
str(a:0:desmista,vysl);
nastrr:=vysl;
End;{nastrr}

function stringup(s:string):string;         {by Istk Attila}
var i:byte;
Begin                       {tenhle postup je rychlejsi nez Upcase}
for i:=1 to byte(s[0]){=length(s)} do
 if s[i] in ['a'..'z'] then s[i]:=char(byte(s[i])-32){=chr(ord(...};
stringup:=s;
End;{stringup}

function stringdown(s:string):string;       {by Istk Attila}
var i:byte;
Begin
for i:=1 to byte(S[0]) do
 if s[i] in ['A'..'Z'] then s[i]:=char(byte(s[i])+32);
stringdown:=s;
End;{stringdown}

function BHC(s:string):string;
var b:byte;
Begin
for b:=1 to byte(s[0]) do
 case s[b] of '':s[b]:='r';
              '':s[b]:='i';
              '':s[b]:='s';
              '':s[b]:='z';
              '':s[b]:='t';
              '':s[b]:='c';
              '':s[b]:='y';
              '':s[b]:='u';
              '':s[b]:='n';
              '':s[b]:='u';
              '':s[b]:='e';
              '':s[b]:='d';
              '':s[b]:='a';
              '':s[b]:='e';
              '':s[b]:='o';
              '':s[b]:='R';
              '':s[b]:='I';
              '':s[b]:='S';
              '':s[b]:='Z';
              '':s[b]:='T';
              '':s[b]:='C';
              '':s[b]:='Y';
              '':s[b]:='U';
              '':s[b]:='N';
              '':s[b]:='U';
              '':s[b]:='E';
              '':s[b]:='D';
              '':s[b]:='A';
              '':s[b]:='E';
              '':s[b]:='O';
              end;
BHC:=s;
End;{BHC}

procedure NactiTexty(var kam:uknaradek; odkud:string; sirka:byte);
var pozice:word;{index pro pohyb v retezci Odkud. Word proto, aby nepretekl pri dojeti za konec retezce (>255)}
    radek:string;{pomocny retezec}
    KonecRadku:boolean;{nastavi se na true, pokud se dojelo na konec radku nebo celeho retezce}
    vybrany:uknaradek;{pro pohyb ve spojovem seznamu}
    velikost:word;{velikost prave alokovaneho radku v B}
{}function slovo:string;
{}{vraci slovo prectene ze vstupniho retezce vcetne pripadne mezery za nim, ale bez znaku pro konec radku}
{}var pom:string;
{}    znak:char;
{}Begin
{}pom:='';
{} repeat
{} znak:=odkud[pozice];
{} if znak='|' then konecradku:=true
{}             else pom:=pom+znak;
{} inc(pozice);
{} until (znak=' ')or(znak='|')or(pozice>byte(odkud[0]));
{}if pozice>byte(odkud[0]) then konecradku:=true;
{}slovo:=pom;
{}End;{slovo}
Begin{nactitexty}
if odkud='' then exit;
if kam=nil then vybrany:=nil {seznam zatim neexistuje}
           else begin {seznam jiz existuje => najdeme konec}
                vybrany:=kam;
                while vybrany^.dalsi<>nil do vybrany:=vybrany^.dalsi;
                end;                   {ted Vybrany ukazuje na posledni radek}
pozice:=1;
 repeat {pro kazdy radek}
 radek:=''; konecradku:=false;
 {nacteni radku:}
  repeat
  radek:=radek+slovo;
  until konecradku or(byte(radek[0])>=sirka);
 {uriznuti pripadne mezery z konce radku:}
 if radek[byte(radek[0])]=' ' then dec(byte(radek[0]));
 {potrebne mnozstvi pameti pro ulozeni radku do pameti:}
 velikost:=byte(radek[0])+5;{= delka radku ve znacich (ruzna) + jeho nulty znak (1B) + velikost ukazatele (4B)}
 if velikost>maxavail then exit;{jestli pamet nestaci, tak uz dal ukladat nebudeme}
 {alokace pameti pro radek (trochu netradicne s Getmem misto New):}
 if vybrany=nil then begin{seznam je zatim prazdny}
                     getmem(kam,velikost);{vytvorime prvni radek}
                     vybrany:=kam;{a nasmerujeme na nej pracovni ukazatel}
                     end
                else begin{v seznamu uz neco je}
                     getmem(vybrany^.dalsi,velikost);{vytvorime novy radek za poslednim}
                     vybrany:=vybrany^.dalsi;{a nastavime na nej ukazatel}
                     end;
 vybrany^.dalsi:=nil;{aby bylo jasne, ze to je posledni radek}
 move(radek[0],vybrany^.obsah[0],byte(radek[0])+1);{prekopirovani radku (celeho, od nulteho znaku)}
 until pozice>byte(odkud[0]);{a to vsechno opakujeme, dokud nejsme na konci vstupniho retezce}
End;{nactitexty}

function NejdelsiRadek(Ceho:uknaradek):byte;
var vybrany:uknaradek;
    max:byte;
Begin
vybrany:=ceho; max:=0;
while vybrany<>nil do
  begin
  if byte(vybrany^.obsah[0])>max then max:=byte(vybrany^.obsah[0]);
  vybrany:=vybrany^.dalsi;
  end;
nejdelsiradek:=max;
End;{nejdelsiradek}

function PocetRadkuVSeznamu(VeKterem:uknaradek):byte;
var vybrany:uknaradek;
    pocet:byte;
Begin
vybrany:=vekterem; pocet:=0;
while vybrany<>nil do begin
                      vybrany:=vybrany^.dalsi;
                      inc(pocet);
                      end;
pocetradkuvseznamu:=pocet;
End;{pocetradkuvseznamu}

procedure ZrusTexty(var ktere:uknaradek);
var vybrany:uknaradek;
    velikost:word;{velikost prave ruseneho radku v B}
Begin
while ktere<>nil do {dokud je co mazat}
  begin
  vybrany:=ktere;{nastavime pomocny ukazatel na prvni radek}
  velikost:=byte(vybrany^.obsah[0])+5;{spocitame velikost}
  ktere:=vybrany^.dalsi;{ukazatel na prvni radek presuneme na nasledujici
       (pokud dojede za konec seznamu, bude mit hodnotu nil a cyklus skonci)}
  freemem(vybrany,velikost);{a vybrany radek smazeme}
  end;
End;{zrustexty}

function ValF(retezec:string; default:longint):longint;
var cislo:longint;
    kod:integer;
Begin
val(retezec,cislo,kod);
if kod=0 then valf:=cislo
         else valf:=default;
End;{valf}

END.